"use strict";
(self["webpackChunkapp"] = self["webpackChunkapp"] || []).push([["node_modules_byteowls_capacitor-oauth2_dist_esm_web_js"],{

/***/ 82466:
/*!***********************************************************************!*\
  !*** ./node_modules/@byteowls/capacitor-oauth2/dist/esm/web-utils.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CryptoUtils: () => (/* binding */ CryptoUtils),
/* harmony export */   WebOptions: () => (/* binding */ WebOptions),
/* harmony export */   WebUtils: () => (/* binding */ WebUtils)
/* harmony export */ });
/* harmony import */ var _Users_philbrozio_Repositorys_planzeit_ionic_v5_neu_node_modules_babel_runtime_helpers_esm_asyncToGenerator_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js */ 89204);

// import sha256 from "fast-sha256";
class WebUtils {
  /**
   * Public only for testing
   */
  static getAppId(options) {
    return this.getOverwritableValue(options, "appId");
  }
  static getOverwritableValue(options, key) {
    let base = options[key];
    if (options.web && key in options.web) {
      base = options.web[key];
    }
    return base;
  }
  /**
   * Public only for testing
   */
  static getAuthorizationUrl(options) {
    let url = options.authorizationBaseUrl + "?client_id=" + options.appId;
    url += "&response_type=" + options.responseType;
    if (options.redirectUrl) {
      url += "&redirect_uri=" + options.redirectUrl;
    }
    if (options.scope) {
      url += "&scope=" + options.scope;
    }
    url += "&state=" + options.state;
    if (options.additionalParameters) {
      for (const key in options.additionalParameters) {
        url += "&" + key + "=" + options.additionalParameters[key];
      }
    }
    if (options.pkceCodeChallenge) {
      url += "&code_challenge=" + options.pkceCodeChallenge;
      url += "&code_challenge_method=" + options.pkceCodeChallengeMethod;
    }
    return encodeURI(url);
  }
  static getTokenEndpointData(options, code) {
    let body = '';
    body += encodeURIComponent('grant_type') + '=' + encodeURIComponent('authorization_code') + '&';
    body += encodeURIComponent('client_id') + '=' + encodeURIComponent(options.appId) + '&';
    body += encodeURIComponent('redirect_uri') + '=' + encodeURIComponent(options.redirectUrl) + '&';
    body += encodeURIComponent('code') + '=' + encodeURIComponent(code) + '&';
    body += encodeURIComponent('code_verifier') + '=' + encodeURIComponent(options.pkceCodeVerifier);
    return body;
  }
  /**
   * Public only for testing
   */
  static getUrlParams(url) {
    const urlString = `${url !== null && url !== void 0 ? url : ''}`.trim();
    if (urlString.length === 0) {
      return;
    }
    const parsedUrl = new URL(urlString);
    if (!parsedUrl.search && !parsedUrl.hash) {
      return;
    }
    let urlParamStr;
    if (parsedUrl.search) {
      urlParamStr = parsedUrl.search.substr(1);
    } else {
      urlParamStr = parsedUrl.hash.substr(1);
    }
    const keyValuePairs = urlParamStr.split(`&`);
    // @ts-ignore
    return keyValuePairs.reduce((accumulator, currentValue) => {
      const [key, val] = currentValue.split(`=`);
      if (key && key.length > 0) {
        return Object.assign(Object.assign({}, accumulator), {
          [key]: decodeURIComponent(val)
        });
      }
    }, {});
  }
  static randomString(length = 10) {
    const haystack = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";
    let randomStr;
    if (window.crypto) {
      let numberArray = new Uint32Array(length);
      window.crypto.getRandomValues(numberArray);
      numberArray = numberArray.map(x => haystack.charCodeAt(x % haystack.length));
      let stringArray = [];
      numberArray.forEach(x => {
        stringArray.push(haystack.charAt(x % haystack.length));
      });
      randomStr = stringArray.join("");
    } else {
      randomStr = "";
      for (let i = 0; i < length; i++) {
        randomStr += haystack.charAt(Math.floor(Math.random() * haystack.length));
      }
    }
    return randomStr;
  }
  static buildWebOptions(configOptions) {
    var _this = this;
    return (0,_Users_philbrozio_Repositorys_planzeit_ionic_v5_neu_node_modules_babel_runtime_helpers_esm_asyncToGenerator_js__WEBPACK_IMPORTED_MODULE_0__["default"])(function* () {
      const webOptions = new WebOptions();
      webOptions.appId = _this.getAppId(configOptions);
      webOptions.authorizationBaseUrl = _this.getOverwritableValue(configOptions, "authorizationBaseUrl");
      webOptions.responseType = _this.getOverwritableValue(configOptions, "responseType");
      if (!webOptions.responseType) {
        webOptions.responseType = "token";
      }
      webOptions.redirectUrl = _this.getOverwritableValue(configOptions, "redirectUrl");
      // controlling parameters
      webOptions.resourceUrl = _this.getOverwritableValue(configOptions, "resourceUrl");
      webOptions.accessTokenEndpoint = _this.getOverwritableValue(configOptions, "accessTokenEndpoint");
      webOptions.pkceEnabled = _this.getOverwritableValue(configOptions, "pkceEnabled");
      if (webOptions.pkceEnabled) {
        webOptions.pkceCodeVerifier = _this.randomString(64);
        if (CryptoUtils.HAS_SUBTLE_CRYPTO) {
          yield CryptoUtils.deriveChallenge(webOptions.pkceCodeVerifier).then(c => {
            webOptions.pkceCodeChallenge = c;
            webOptions.pkceCodeChallengeMethod = "S256";
          });
        } else {
          webOptions.pkceCodeChallenge = webOptions.pkceCodeVerifier;
          webOptions.pkceCodeChallengeMethod = "plain";
        }
      }
      webOptions.scope = _this.getOverwritableValue(configOptions, "scope");
      webOptions.state = _this.getOverwritableValue(configOptions, "state");
      if (!webOptions.state || webOptions.state.length === 0) {
        webOptions.state = _this.randomString(20);
      }
      let parametersMapHelper = _this.getOverwritableValue(configOptions, "additionalParameters");
      if (parametersMapHelper) {
        webOptions.additionalParameters = {};
        for (const key in parametersMapHelper) {
          if (key && key.trim().length > 0) {
            let value = parametersMapHelper[key];
            if (value && value.trim().length > 0) {
              webOptions.additionalParameters[key] = value;
            }
          }
        }
      }
      let headersMapHelper = _this.getOverwritableValue(configOptions, "additionalResourceHeaders");
      if (headersMapHelper) {
        webOptions.additionalResourceHeaders = {};
        for (const key in headersMapHelper) {
          if (key && key.trim().length > 0) {
            let value = headersMapHelper[key];
            if (value && value.trim().length > 0) {
              webOptions.additionalResourceHeaders[key] = value;
            }
          }
        }
      }
      webOptions.logsEnabled = _this.getOverwritableValue(configOptions, "logsEnabled");
      return webOptions;
    })();
  }
  static buildWindowOptions(configOptions) {
    const windowOptions = new WebOptions();
    if (configOptions.web) {
      if (configOptions.web.windowOptions) {
        windowOptions.windowOptions = configOptions.web.windowOptions;
      }
      if (configOptions.web.windowTarget) {
        windowOptions.windowTarget = configOptions.web.windowTarget;
      }
    }
    return windowOptions;
  }
}
class CryptoUtils {
  static toUint8Array(str) {
    const buf = new ArrayBuffer(str.length);
    const bufView = new Uint8Array(buf);
    for (let i = 0; i < str.length; i++) {
      bufView[i] = str.charCodeAt(i);
    }
    return bufView;
  }
  static toBase64Url(base64) {
    return base64.replace(/\+/g, '-').replace(/\//g, '_').replace(/=/g, '');
  }
  static toBase64(bytes) {
    let len = bytes.length;
    let base64 = "";
    for (let i = 0; i < len; i += 3) {
      base64 += this.BASE64_CHARS[bytes[i] >> 2];
      base64 += this.BASE64_CHARS[(bytes[i] & 3) << 4 | bytes[i + 1] >> 4];
      base64 += this.BASE64_CHARS[(bytes[i + 1] & 15) << 2 | bytes[i + 2] >> 6];
      base64 += this.BASE64_CHARS[bytes[i + 2] & 63];
    }
    if (len % 3 === 2) {
      base64 = base64.substring(0, base64.length - 1) + "=";
    } else if (len % 3 === 1) {
      base64 = base64.substring(0, base64.length - 2) + "==";
    }
    return base64;
  }
  static deriveChallenge(codeVerifier) {
    if (codeVerifier.length < 43 || codeVerifier.length > 128) {
      return Promise.reject(new Error('ERR_PKCE_CODE_VERIFIER_INVALID_LENGTH'));
    }
    if (!CryptoUtils.HAS_SUBTLE_CRYPTO) {
      return Promise.reject(new Error('ERR_PKCE_CRYPTO_NOTSUPPORTED'));
    }
    return new Promise((resolve, reject) => {
      crypto.subtle.digest('SHA-256', this.toUint8Array(codeVerifier)).then(arrayBuffer => {
        return resolve(this.toBase64Url(this.toBase64(new Uint8Array(arrayBuffer))));
      }, error => reject(error));
    });
  }
}
CryptoUtils.BASE64_CHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
CryptoUtils.HAS_SUBTLE_CRYPTO = typeof window !== 'undefined' && !!window.crypto && !!window.crypto.subtle;
class WebOptions {
  constructor() {
    this.windowTarget = "_blank";
  }
}

/***/ }),

/***/ 51138:
/*!*****************************************************************!*\
  !*** ./node_modules/@byteowls/capacitor-oauth2/dist/esm/web.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   OAuth2ClientPluginWeb: () => (/* binding */ OAuth2ClientPluginWeb)
/* harmony export */ });
/* harmony import */ var _Users_philbrozio_Repositorys_planzeit_ionic_v5_neu_node_modules_babel_runtime_helpers_esm_asyncToGenerator_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js */ 89204);
/* harmony import */ var _capacitor_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @capacitor/core */ 14070);
/* harmony import */ var _web_utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./web-utils */ 82466);



class OAuth2ClientPluginWeb extends _capacitor_core__WEBPACK_IMPORTED_MODULE_1__.WebPlugin {
  constructor() {
    super(...arguments);
    this.loopCount = 2000;
    this.intervalLength = 100;
    this.MSG_RETURNED_TO_JS = "Returned to JS:";
  }
  /**
   * Get a new access token using an existing refresh token.
   */
  refreshToken(_options) {
    return (0,_Users_philbrozio_Repositorys_planzeit_ionic_v5_neu_node_modules_babel_runtime_helpers_esm_asyncToGenerator_js__WEBPACK_IMPORTED_MODULE_0__["default"])(function* () {
      return new Promise((_resolve, reject) => {
        reject(new Error("Functionality not implemented for PWAs yet"));
      });
    })();
  }
  authenticate(options) {
    var _this = this;
    return (0,_Users_philbrozio_Repositorys_planzeit_ionic_v5_neu_node_modules_babel_runtime_helpers_esm_asyncToGenerator_js__WEBPACK_IMPORTED_MODULE_0__["default"])(function* () {
      const windowOptions = _web_utils__WEBPACK_IMPORTED_MODULE_2__.WebUtils.buildWindowOptions(options);
      // we open the window first to avoid popups being blocked because of
      // the asynchronous buildWebOptions call
      _this.windowHandle = window.open('', windowOptions.windowTarget, windowOptions.windowOptions);
      _this.webOptions = yield _web_utils__WEBPACK_IMPORTED_MODULE_2__.WebUtils.buildWebOptions(options);
      return new Promise((resolve, reject) => {
        // validate
        if (!_this.webOptions.appId || _this.webOptions.appId.length == 0) {
          reject(new Error("ERR_PARAM_NO_APP_ID"));
        } else if (!_this.webOptions.authorizationBaseUrl || _this.webOptions.authorizationBaseUrl.length == 0) {
          reject(new Error("ERR_PARAM_NO_AUTHORIZATION_BASE_URL"));
        } else if (!_this.webOptions.redirectUrl || _this.webOptions.redirectUrl.length == 0) {
          reject(new Error("ERR_PARAM_NO_REDIRECT_URL"));
        } else if (!_this.webOptions.responseType || _this.webOptions.responseType.length == 0) {
          reject(new Error("ERR_PARAM_NO_RESPONSE_TYPE"));
        } else {
          // init internal control params
          let loopCount = _this.loopCount;
          _this.windowClosedByPlugin = false;
          // open window
          const authorizationUrl = _web_utils__WEBPACK_IMPORTED_MODULE_2__.WebUtils.getAuthorizationUrl(_this.webOptions);
          if (_this.webOptions.logsEnabled) {
            _this.doLog("Authorization url: " + authorizationUrl);
          }
          if (_this.windowHandle) {
            _this.windowHandle.location.href = authorizationUrl;
          }
          // wait for redirect and resolve the
          _this.intervalId = window.setInterval(() => {
            var _a, _b;
            if (loopCount-- < 0) {
              _this.closeWindow();
            } else if (((_a = _this.windowHandle) === null || _a === void 0 ? void 0 : _a.closed) && !_this.windowClosedByPlugin) {
              window.clearInterval(_this.intervalId);
              reject(new Error("USER_CANCELLED"));
            } else {
              let href = undefined;
              try {
                href = (_b = _this.windowHandle) === null || _b === void 0 ? void 0 : _b.location.href;
              } catch (ignore) {
                // ignore DOMException: Blocked a frame with origin "http://localhost:4200" from accessing a cross-origin frame.
              }
              if (href != null && href.indexOf(_this.webOptions.redirectUrl) >= 0) {
                if (_this.webOptions.logsEnabled) {
                  _this.doLog("Url from Provider: " + href);
                }
                let authorizationRedirectUrlParamObj = _web_utils__WEBPACK_IMPORTED_MODULE_2__.WebUtils.getUrlParams(href);
                if (authorizationRedirectUrlParamObj) {
                  if (_this.webOptions.logsEnabled) {
                    _this.doLog("Authorization response:", authorizationRedirectUrlParamObj);
                  }
                  window.clearInterval(_this.intervalId);
                  // check state
                  if (authorizationRedirectUrlParamObj.state === _this.webOptions.state) {
                    if (_this.webOptions.accessTokenEndpoint) {
                      const self = _this;
                      let authorizationCode = authorizationRedirectUrlParamObj.code;
                      if (authorizationCode) {
                        const tokenRequest = new XMLHttpRequest();
                        tokenRequest.onload = function () {
                          if (this.status === 200) {
                            let accessTokenResponse = JSON.parse(this.response);
                            if (self.webOptions.logsEnabled) {
                              self.doLog("Access token response:", accessTokenResponse);
                            }
                            self.requestResource(accessTokenResponse.access_token, resolve, reject, authorizationRedirectUrlParamObj, accessTokenResponse);
                          }
                        };
                        tokenRequest.onerror = function () {
                          // always log error because of CORS hint
                          self.doLog("ERR_GENERAL: See client logs. It might be CORS. Status text: " + this.statusText);
                          reject(new Error("ERR_GENERAL"));
                        };
                        tokenRequest.open("POST", _this.webOptions.accessTokenEndpoint, true);
                        tokenRequest.setRequestHeader('accept', 'application/json');
                        tokenRequest.setRequestHeader('cache-control', 'no-cache');
                        tokenRequest.setRequestHeader('content-type', 'application/x-www-form-urlencoded');
                        tokenRequest.send(_web_utils__WEBPACK_IMPORTED_MODULE_2__.WebUtils.getTokenEndpointData(_this.webOptions, authorizationCode));
                      } else {
                        reject(new Error("ERR_NO_AUTHORIZATION_CODE"));
                      }
                      _this.closeWindow();
                    } else {
                      // if no accessTokenEndpoint exists request the resource
                      _this.requestResource(authorizationRedirectUrlParamObj.access_token, resolve, reject, authorizationRedirectUrlParamObj);
                    }
                  } else {
                    if (_this.webOptions.logsEnabled) {
                      _this.doLog("State from web options: " + _this.webOptions.state);
                      _this.doLog("State returned from provider: " + authorizationRedirectUrlParamObj.state);
                    }
                    reject(new Error("ERR_STATES_NOT_MATCH"));
                    _this.closeWindow();
                  }
                }
                // this is no error no else clause required
              }
            }
          }, _this.intervalLength);
        }
      });
    })();
  }
  requestResource(accessToken, resolve, reject, authorizationResponse, accessTokenResponse = null) {
    if (this.webOptions.resourceUrl) {
      const logsEnabled = this.webOptions.logsEnabled;
      if (logsEnabled) {
        this.doLog("Resource url: " + this.webOptions.resourceUrl);
      }
      if (accessToken) {
        if (logsEnabled) {
          this.doLog("Access token:", accessToken);
        }
        const self = this;
        const request = new XMLHttpRequest();
        request.onload = function () {
          if (this.status === 200) {
            let resp = JSON.parse(this.response);
            if (logsEnabled) {
              self.doLog("Resource response:", resp);
            }
            if (resp) {
              self.assignResponses(resp, accessToken, authorizationResponse, accessTokenResponse);
            }
            if (logsEnabled) {
              self.doLog(self.MSG_RETURNED_TO_JS, resp);
            }
            resolve(resp);
          } else {
            reject(new Error(this.statusText));
          }
          self.closeWindow();
        };
        request.onerror = function () {
          if (logsEnabled) {
            self.doLog("ERR_GENERAL: " + this.statusText);
          }
          reject(new Error("ERR_GENERAL"));
          self.closeWindow();
        };
        request.open("GET", this.webOptions.resourceUrl, true);
        request.setRequestHeader('Authorization', `Bearer ${accessToken}`);
        if (this.webOptions.additionalResourceHeaders) {
          for (const key in this.webOptions.additionalResourceHeaders) {
            request.setRequestHeader(key, this.webOptions.additionalResourceHeaders[key]);
          }
        }
        request.send();
      } else {
        if (logsEnabled) {
          this.doLog("No accessToken was provided although you configured a resourceUrl. Remove the resourceUrl from the config.");
        }
        reject(new Error("ERR_NO_ACCESS_TOKEN"));
        this.closeWindow();
      }
    } else {
      // if no resource url exists just return the accessToken response
      const resp = {};
      this.assignResponses(resp, accessToken, authorizationResponse, accessTokenResponse);
      if (this.webOptions.logsEnabled) {
        this.doLog(this.MSG_RETURNED_TO_JS, resp);
      }
      resolve(resp);
      this.closeWindow();
    }
  }
  assignResponses(resp, accessToken, authorizationResponse, accessTokenResponse = null) {
    // #154
    if (authorizationResponse) {
      resp["authorization_response"] = authorizationResponse;
    }
    if (accessTokenResponse) {
      resp["access_token_response"] = accessTokenResponse;
    }
    resp["access_token"] = accessToken;
  }
  logout(options) {
    return (0,_Users_philbrozio_Repositorys_planzeit_ionic_v5_neu_node_modules_babel_runtime_helpers_esm_asyncToGenerator_js__WEBPACK_IMPORTED_MODULE_0__["default"])(function* () {
      return new Promise((resolve, _reject) => {
        localStorage.removeItem(_web_utils__WEBPACK_IMPORTED_MODULE_2__.WebUtils.getAppId(options));
        resolve(true);
      });
    })();
  }
  closeWindow() {
    var _a;
    window.clearInterval(this.intervalId);
    // #164 if the provider's login page is opened in the same tab or window it must not be closed
    // if (this.webOptions.windowTarget !== "_self") {
    //     this.windowHandle?.close();
    // }
    (_a = this.windowHandle) === null || _a === void 0 ? void 0 : _a.close();
    this.windowClosedByPlugin = true;
  }
  doLog(msg, obj = null) {
    console.log("I/Capacitor/OAuth2ClientPlugin: " + msg, obj);
  }
}

/***/ })

}]);
//# sourceMappingURL=node_modules_byteowls_capacitor-oauth2_dist_esm_web_js.js.map